/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.mospcommon.system.dao;

import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseDao;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.mospcommon.system.dto.CmAgreementOverTimeDto;

/**
 * CM_AGREEMENT_OVER_TIME(時間外協定マスタ)のDAOクラス 。
 */
public class CmAgreementOverTimeDao extends BaseDao {
	
	// テーブル名及びキー列名
	/**
	 * CM_AGREEMENT_OVER_TIME(時間外協定マスタ)。
	 */
	public static final String	TABLE							= "CM_AGREEMENT_OVER_TIME";
	
	/**
	 * KEY_1 = OVER_TIME_ID(時間外協定ID)。
	 */
	public static final String	KEY_1							= "OVER_TIME_ID";
	
	// 列名
	/**
	 * OVER_TIME_ID(時間外協定ID)。
	 */
	public static final String	COL_OVER_TIME_ID				= "OVER_TIME_ID";
	/**
	 * OVER_TIME_CODE(時間外協定コード)。
	 */
	public static final String	COL_OVER_TIME_CODE				= "OVER_TIME_CODE";
	/**
	 * WORK_TYPE_NAME(業務の種類)。
	 */
	public static final String	COL_WORK_TYPE_NAME				= "WORK_TYPE_NAME";
	/**
	 * CAUSE(具体的事由)。
	 */
	public static final String	COL_CAUSE						= "CAUSE";
	/**
	 * AGREE_TYPE(協定種類)。
	 */
	public static final String	COL_AGREE_TYPE					= "AGREE_TYPE";
	/**
	 * LIMIT_CODE(限度基準コード)。
	 */
	public static final String	COL_LIMIT_CODE					= "LIMIT_CODE";
	/**
	 * OVER_TIME_RATE(時間外割増賃金率)。
	 */
	public static final String	COL_OVER_TIME_RATE				= "OVER_TIME_RATE";
	/**
	 * CAUTION_MONTH(月60時間時間外警告時間)。
	 */
	public static final String	COL_CAUTION_MONTH				= "CAUTION_MONTH";
	/**
	 * MONTHLY_OVER_TIME_RATE(月60時間時間外割増賃金率)。
	 */
	public static final String	COL_MONTHLY_OVER_TIME_RATE		= "MONTHLY_OVER_TIME_RATE";
	/**
	 * SUB_ACQUIRE_RATE(代替休暇取得割増賃金率)。
	 */
	public static final String	COL_SUB_ACQUIRE_RATE			= "SUB_ACQUIRE_RATE";
	/**
	 * SUB_ACQUIRE_HOLIDAY_RATE(代替休暇取得休日割増賃金率)。
	 */
	public static final String	COL_SUB_ACQUIRE_HOLIDAY_RATE	= "SUB_ACQUIRE_HOLIDAY_RATE";
	/**
	 * SUB_QUIT_RATE(代替休暇放棄割増賃金率)。
	 */
	public static final String	COL_SUB_QUIT_RATE				= "SUB_QUIT_RATE";
	/**
	 * START_DATE(開始年月日)。
	 */
	public static final String	COL_START_DATE					= "START_DATE";
	/**
	 * DELETE_FLAG(削除フラグ)。
	 */
	public static final String	COL_DELETE_FLAG					= "DELETE_FLAG";
	

	/**
	 * コンストラクタ。
	 */
	public CmAgreementOverTimeDao() {
		super();
		INSERT_DATE = "INSERT_DATE";
		INSERT_USER = "INSERT_USER";
		UPDATE_DATE = "UPDATE_DATE";
		UPDATE_USER = "UPDATE_USER";
	}
	
	/**
	 * 検索結果取得(DTOのList)。
	 * @return 検索結果リスト
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private List<CmAgreementOverTimeDto> mappingAll() throws SQLException {
		List<CmAgreementOverTimeDto> all = new ArrayList<CmAgreementOverTimeDto>();
		while (rs.next()) {
			all.add(mapping());
		}
		return all;
	}
	
	/**
	 * 検索結果取得(DTO)。
	 * @return CM_AGREEMENT_OVER_TIMEレコード
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private CmAgreementOverTimeDto mapping() throws SQLException {
		CmAgreementOverTimeDto dto = new CmAgreementOverTimeDto();
		dto.setOverTimeId(rs.getInt(COL_OVER_TIME_ID));
		dto.setOverTimeCode(rs.getString(COL_OVER_TIME_CODE));
		dto.setWorkTypeName(rs.getString(COL_WORK_TYPE_NAME));
		dto.setCause(rs.getString(COL_CAUSE));
		dto.setAgreeType(rs.getString(COL_AGREE_TYPE));
		dto.setLimitCode(rs.getString(COL_LIMIT_CODE));
		dto.setOverTimeRate(rs.getInt(COL_OVER_TIME_RATE));
		dto.setCautionMonth(rs.getInt(COL_CAUTION_MONTH));
		dto.setMonthlyOverTimeRate(rs.getInt(COL_MONTHLY_OVER_TIME_RATE));
		dto.setSubAcquireRate(rs.getInt(COL_SUB_ACQUIRE_RATE));
		dto.setSubAcquireHolidayRate(rs.getInt(COL_SUB_ACQUIRE_HOLIDAY_RATE));
		dto.setSubQuitRate(rs.getInt(COL_SUB_QUIT_RATE));
		dto.setStartDate(rs.getDate(COL_START_DATE));
		dto.setDeleteFlag(rs.getInt(COL_DELETE_FLAG));
		mappingCommonInfo(dto);
		return dto;
	}
	
	/**
	 * 全データ取得。
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementOverTimeDto> findAll() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			prepareStatement(getSelectQuery(getClass()) + getOrderForKey(getClass()));
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによるデータ取得。
	 * @param overTimeId 時間外協定ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementOverTimeDto findForKey(int overTimeId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()));
			setParam(index++, overTimeId);
			executeQuery();
			CmAgreementOverTimeDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * キーによる行ロック取得。
	 * @param overTimeId 時間外協定ID
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementOverTimeDto findForUpdate(int overTimeId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			prepareStatement(getSelectQuery(getClass()) + getConditionForKey(getClass()) + getForUpdate());
			setParam(index++, overTimeId);
			executeQuery();
			CmAgreementOverTimeDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param overTimeId 時間外協定ID
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementOverTimeDto> findForCondition(int overTimeId) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_OVER_TIME_ID);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, overTimeId);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param overTimeCode 時間外協定コー
	 * @param workTypeName 業務の種類
	 * @param deleteFlag 削除フラグ
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementOverTimeDto> findForCondition(String overTimeCode, String workTypeName, String deleteFlag)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_OVER_TIME_CODE);
		sb.append(" LIKE ? AND ");
		sb.append(COL_WORK_TYPE_NAME);
		sb.append(" LIKE ? ");
		if (!deleteFlag.equals("")) {
			sb.append("AND ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ? ");
		}
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, overTimeCode + "%");
			setParam(index++, "%" + workTypeName + "%");
			if (!deleteFlag.equals("")) {
				setParam(index++, Integer.parseInt(deleteFlag));
			}
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param overTimeCode 時間外協定コード
	 * @param startdate 時間外協定コード
	 * @param deleteFlag 削除フラグ
	 * @return 検索結果(DTOのList)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public List<CmAgreementOverTimeDto> findForCondition(String overTimeCode, Date startdate, int deleteFlag)
			throws SQLException, IllegalAccessException, NoSuchFieldException {
		index = 1;
		StringBuffer sb = new StringBuffer();
		sb.append(" WHERE ");
		sb.append(COL_OVER_TIME_CODE);
		sb.append(" = ? ");
		sb.append("AND ");
		sb.append(COL_START_DATE);
		sb.append(" = ? ");
		sb.append("AND ");
		sb.append(COL_DELETE_FLAG);
		sb.append(" = ? ");
		try {
			prepareStatement(getSelectQuery(getClass()) + sb.toString() + getOrderForKey(getClass()));
			setParam(index++, overTimeCode);
			setParam(index++, startdate);
			setParam(index++, deleteFlag);
			executeQuery();
			return mappingAll();
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param overTimeCode 時間外協定コード
	 * @param targetDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementOverTimeDto findForAgreement(String overTimeCode, Date targetDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_OVER_TIME_CODE);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" <= ? ");
			sb.append(getOrderBy());
			sb.append(COL_START_DATE);
			sb.append(" ");
			sb.append(getDesc());
			sb.append(getLimit());
			sb.append("1");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, overTimeCode);
			setParam(index++, targetDate);
			executeQuery();
			CmAgreementOverTimeDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 条件文によるデータ取得。
	 * @param overTimeCode 時間外協定コード
	 * @param targetDate 対象年月日
	 * @return 検索結果(DTO)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 */
	public CmAgreementOverTimeDto findForStartDate(String overTimeCode, Date targetDate) throws SQLException,
			IllegalAccessException, NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = " + MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_OVER_TIME_CODE);
			sb.append(" = ?");
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" = ? ");
			prepareStatement(getSelectQuery(getClass()) + sb.toString());
			setParam(index++, overTimeCode);
			setParam(index++, targetDate);
			executeQuery();
			CmAgreementOverTimeDto dto = null;
			if (rs.next()) {
				dto = mapping();
			}
			return dto;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * max値取得
	 * @return String　最大連番
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException	フィールドが見つからなかった場合
	 */
	public String findForMax() throws SQLException, IllegalAccessException, NoSuchFieldException {
		try {
			String max = "";
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT MAX(");
			sb.append(COL_OVER_TIME_ID);
			sb.append(") FROM ");
			sb.append(TABLE);
			prepareStatement(sb.toString());
			executeQuery();
			if (rs.next()) {
				max = String.valueOf(rs.getLong(1));
			}
			return max;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * 時間外協定コード取得
	 * @param targetDate 対象年月日
	 * @return 検索結果
	 * @throws SQLException SQL例外が発生した場合
	 * @throws IllegalAccessException メソッドにアクセスできない場合
	 * @throws NoSuchFieldException フィールドが見つからなかった場合
	 */
	public List<String> findForOverTimeCode(Date targetDate) throws SQLException, IllegalAccessException,
			NoSuchFieldException {
		try {
			index = 1;
			StringBuffer sb = new StringBuffer();
			sb.append("SELECT DISTINCT ");
			sb.append(COL_OVER_TIME_CODE);
			sb.append(" FROM ");
			sb.append(TABLE);
			sb.append(" WHERE ");
			sb.append(COL_DELETE_FLAG);
			sb.append(" = ");
			sb.append(MospConst.DELETE_FLAG_OFF);
			sb.append(" AND ");
			sb.append(COL_START_DATE);
			sb.append(" <= ?");
			prepareStatement(sb.toString());
			setParam(index++, targetDate);
			executeQuery();
			List<String> list = new ArrayList<String>();
			while (rs.next()) {
				list.add(rs.getString(COL_OVER_TIME_CODE));
			}
			return list;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ挿入。
	 * @param dto 挿入対象DTO
	 * @return int 挿入結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int insert(CmAgreementOverTimeDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getInsertQuery(getClass()));
			setParams(dto, true);
			executeUpdate();
			chkInsert(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ更新。
	 * @param dto 更新対象DTO
	 * @return int 更新結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int update(CmAgreementOverTimeDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getUpdateQuery(getClass()));
			setParams(dto, false);
			setParam(index++, dto.getOverTimeId());
			executeUpdate();
			chkUpdate(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * データ削除。
	 * @param dto 更新対象DTO
	 * @return int 削除結果(件数)
	 * @throws SQLException 	SQL例外が発生した場合
	 * @throws IllegalAccessException 	メソッドにアクセスできない場合
	 * @throws NoSuchFieldException 	フィールドが見つからなかった場合
	 * @throws MospException 	MosP例外処理が発生した場合
	 */
	public int delete(CmAgreementOverTimeDto dto) throws SQLException, IllegalAccessException, NoSuchFieldException,
			MospException {
		try {
			index = 1;
			prepareStatement(getDeleteQuery(getClass()));
			setParam(index++, dto.getOverTimeId());
			executeUpdate();
			chkDelete(1);
			return cnt;
		} catch (SQLException e) {
			throw e;
		} finally {
			releaseResultSet();
			releasePreparedStatement();
		}
	}
	
	/**
	 * パラメータ設定。
	 * @param dto 更新対象DTO
	 * @param isInsert 挿入文フラグ(true：挿入文、false：挿入文)
	 * @throws SQLException 	SQL例外が発生した場合
	 */
	private void setParams(CmAgreementOverTimeDto dto, boolean isInsert) throws SQLException {
		setParam(index++, dto.getOverTimeId());
		setParam(index++, dto.getOverTimeCode());
		setParam(index++, dto.getWorkTypeName());
		setParam(index++, dto.getCause());
		setParam(index++, dto.getAgreeType());
		setParam(index++, dto.getLimitCode());
		setParam(index++, dto.getOverTimeRate());
		setParam(index++, dto.getCautionMonth());
		setParam(index++, dto.getMonthlyOverTimeRate());
		setParam(index++, dto.getSubAcquireRate());
		setParam(index++, dto.getSubAcquireHolidayRate());
		setParam(index++, dto.getSubQuitRate());
		setParam(index++, dto.getStartDate());
		setParam(index++, dto.getDeleteFlag());
		setCommonParams(isInsert);
	}
	
}
